"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitReporter = void 0;
var faker_1 = __importDefault(require("faker"));
var GitReporter = /** @class */ (function () {
    function GitReporter() {
    }
    GitReporter.generateAccumulatedGitReport = function (reports) {
        return reports.reduce(function (acc, report) { return ({
            weeks: report.weeks,
            projects: __spread(acc.projects, [report.project]),
            committers: GitReporter.combineCommitters(acc.committers, report.committers),
            totalCommits: acc.totalCommits + report.totalCommits
        }); }, {
            weeks: 0,
            totalCommits: 0,
            committers: [],
            projects: []
        });
    };
    GitReporter.anonymizeAccumulatedGitReport = function (report) {
        return __assign(__assign({}, report), { committers: report.committers.map(function (committer) { return (__assign(__assign({}, committer), { email: faker_1.default.internet.email(), name: faker_1.default.name.findName() })); }) });
    };
    GitReporter.combineCommitters = function (accCommitters, committers) {
        return Object.values(__spread(accCommitters, committers).reduce(function (committersDictionary, committer) {
            var _a;
            var accumulatedCommitterInfo = GitReporter.getCommitter(committer.email, committersDictionary);
            return __assign(__assign({}, committersDictionary), (_a = {}, _a[committer.email] = {
                email: committer.email,
                name: committer.name,
                totalDeletions: committer.totalDeletions + accumulatedCommitterInfo.totalDeletions,
                totalInsertions: committer.totalInsertions + accumulatedCommitterInfo.totalInsertions,
                totalCommits: committer.totalCommits + accumulatedCommitterInfo.totalCommits,
                totalFilesChanged: committer.totalFilesChanged + accumulatedCommitterInfo.totalFilesChanged
            }, _a));
        }, {}));
    };
    GitReporter.getCommitter = function (committerEmail, committersDictionary) {
        var committer = committersDictionary[committerEmail];
        return committer || {
            email: committerEmail,
            name: '',
            totalDeletions: 0,
            totalInsertions: 0,
            totalCommits: 0,
            totalFilesChanged: 0
        };
    };
    return GitReporter;
}());
exports.GitReporter = GitReporter;
//# sourceMappingURL=gitReport.js.map