"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitReportController = void 0;
var tsyringe_1 = require("tsyringe");
var gitReport_service_1 = require("../domain/gitReport.service");
var os_1 = require("os");
var notifier_1 = require("../../notifier");
var logger_1 = require("../../logger");
var GitReportController = /** @class */ (function () {
    function GitReportController(service, notifier, log) {
        this.service = service;
        this.notifier = notifier;
        this.log = log;
    }
    GitReportController_1 = GitReportController;
    GitReportController.prototype.exec = function (_a) {
        var allInDirectory = _a.allInDirectory, anonymize = _a.anonymize, projects = _a.projects, weeks = _a.weeks, slackUrl = _a.slackUrl;
        return __awaiter(this, void 0, void 0, function () {
            var report, _b, _c, reportOutput;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (!allInDirectory) return [3 /*break*/, 5];
                        if (!anonymize) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.service.generateAnonymousReportForAllProjectsInADirectory(allInDirectory, weeks)];
                    case 1:
                        _b = _d.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.service.generateReportForAllProjectsInADirectory(allInDirectory, weeks)];
                    case 3:
                        _b = _d.sent();
                        _d.label = 4;
                    case 4:
                        report = _b;
                        return [3 /*break*/, 10];
                    case 5:
                        if (!anonymize) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.service.generateAnonymousReport(projects, weeks)];
                    case 6:
                        _c = _d.sent();
                        return [3 /*break*/, 9];
                    case 7: return [4 /*yield*/, this.service.generateReport(projects, weeks)];
                    case 8:
                        _c = _d.sent();
                        _d.label = 9;
                    case 9:
                        report = _c;
                        _d.label = 10;
                    case 10:
                        reportOutput = GitReportController_1.generateReportOutput(report);
                        this.log.info(reportOutput);
                        if (!slackUrl) return [3 /*break*/, 12];
                        return [4 /*yield*/, this.notifier.publishOnSlack(slackUrl, reportOutput)];
                    case 11:
                        _d.sent();
                        this.log.info('Report published on Slack.');
                        _d.label = 12;
                    case 12: return [2 /*return*/];
                }
            });
        });
    };
    GitReportController.generateReportOutput = function (report) {
        return "\nReport for: \n" + report.projects.map(function (project) { return "    " + project; }).join(os_1.EOL) + "\n\nTotal commits in the last " + report.weeks + " weeks: " + report.totalCommits + "\nContributions by author:\n" + report.committers.map(function (_a) {
            var name = _a.name, email = _a.email, totalCommits = _a.totalCommits, totalFilesChanged = _a.totalFilesChanged, totalInsertions = _a.totalInsertions, totalDeletions = _a.totalDeletions;
            return os_1.EOL + "    " + name + " (" + email + "):\n      Commits: " + totalCommits + "\n      Files changed: " + totalFilesChanged + "\n      Insertions: " + totalInsertions + "\n      Deletions: " + totalDeletions;
        }).join(os_1.EOL) + "\n";
    };
    var GitReportController_1;
    GitReportController = GitReportController_1 = __decorate([
        tsyringe_1.injectable(),
        __param(0, tsyringe_1.inject(gitReport_service_1.GitReportService)),
        __param(1, tsyringe_1.inject(notifier_1.Notifier)),
        __param(2, tsyringe_1.inject(logger_1.Logger)),
        __metadata("design:paramtypes", [gitReport_service_1.GitReportService,
            notifier_1.Notifier,
            logger_1.Logger])
    ], GitReportController);
    return GitReportController;
}());
exports.GitReportController = GitReportController;
//# sourceMappingURL=gitReport.controller.js.map